﻿Public Class frmDeviceSelect

    Private Const RBWIDTH As Integer = 40
    Private Const LMARGIN As Integer = 20
    Private Const RMARGIN As Integer = 10

    Private WithEvents sys As QD02System = New QD02System

    Private Sub SelectDevice(ByVal logaddr As Integer)
        Dim frmMain As frmQD02 = New frmQD02(logaddr)
        frmMain.Show()
        Me.Close()
    End Sub

    Private Sub rbDeviceSelectHandler(ByVal sender As System.Object, ByVal e As System.EventArgs)
        SelectDevice(CInt(CType(sender, RadioButton).Text))
    End Sub

    Private Sub ErrorHandler(ByVal ErrCode As Integer, ByVal ErrMsg As String) Handles sys.SystemError
        MsgBox(ErrMsg, MsgBoxStyle.Critical, "QD02 Error")
        Application.Exit()  ' terminate program
    End Sub

    Private Sub Form_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim devmask As Integer = sys.EnumerateRinglights()    ' Find all QD02 devices
        ' Create device select groupbox
        Dim ndev As Integer = 0 ' number of found devices
        Dim devnum As Integer   ' logical address of last found device
        Dim box As New GroupBox
        With box
            .Text = "Select QB02 Device"
            .Location = New Point(10, 10)
            .Size = New Size(LMARGIN + MAX_NUM_DEVICES * (RBWIDTH + RMARGIN), 50)
        End With
        ' Create device select radiobuttons
        For logaddr As Integer = 0 To MAX_NUM_DEVICES - 1
            Dim rb As New RadioButton
            rb.Text = logaddr.ToString
            rb.Location = New Point(LMARGIN + logaddr * (RBWIDTH + RMARGIN), 20)
            rb.Width = RBWIDTH
            rb.Enabled = ((devmask And (1 << logaddr)) <> 0)
            If (rb.Enabled) Then
                AddHandler rb.CheckedChanged, AddressOf rbDeviceSelectHandler
                ndev += 1           ' bump device count
                devnum = logaddr    ' remember address of last found device
            End If
            box.Controls.Add(rb)
        Next
        Me.Controls.Add(box)
        If (ndev = 1) Then SelectDevice(devnum) ' If there's only one attached QD02 then select it automatically
    End Sub
End Class